<p>Most developers at OpenCraft will need a devstack that tracks the latest ("master" / "main") development version of the Open edX platform and related projects like Tutor.</p>
<p>Generally, you can <a href="https://docs.tutor.edly.io/dev.html">follow the Tutor documentation</a> for how to install and set up Tutor Main. But before you do that, we highly recommend you set up a virtual environment manager to manage the python virtual environment for your new devstack. You can use <a href="https://mise.jdx.dev/">mise</a>, <a href="https://github.com/astral-sh/uv">uv</a>, <a href="https://direnv.net/">direnv</a>, <a href="https://github.com/pyenv/pyenv">pyenv</a>, <a href="https://asdf-vm.com/guide/introduction.html">asdf</a>, or any similar tool of your choice. In particular, we recommend that you use that tool to set the environment variable TUTOR_ROOT to the directory of your devstack. That variable determines where Tutor keeps all of its data and changing it from the default will help you in two ways: (1) it keeps your various devstacks isolated from each other, and (2) it makes it easier to find, inspect, and modify the important Tutor data files like config.yml.</p>
<p>Here is an example of creating a new "master" Open edX devstack using Tutor Main and mise:</p>
<pre>mkdir tutor-devstack
cd tutor-devstack
mise use python@3.12
# Tell mise to create a venv here instead of using a shared python install:
mise config set env._.python.venv.path .venv
mise config set env._.python.venv.create true
# Tell Tutor to store its data here, separate from other devstacks:
mise set TUTOR_ROOT=$(pwd)
mise set TUTOR_PLUGINS_ROOT=$(pwd)/plugins

# Set up Tutor Main
git clone -b main git@github.com:overhangio/tutor.git
pip install -e "./tutor[full]"
# If you have uv installed globally, prefix the command with uv, as pip isn't available in the venv
# uv pip install -e "./tutor[full]"

# Set up edx-platform
git clone git@github.com:openedx/edx-platform.git
tutor mounts add ./edx-platform

# Launch the devstack
tutor images build openedx-dev
tutor dev launch

# Setup
tutor dev do createuser --staff --superuser YourName yourname@opencraft.com
tutor dev do importdemocourse
</pre>
<p>Access your new devstack at the URLs printed at the end of the <code>tutor dev launch</code> step.</p>